Attribute VB_Name = "Remove_duplicate_objects"
Option Explicit

Sub RemoveDuplicateObjects()
   Dim s As Shape, sr As New ShapeRange, props() As Double
   Dim toDel As New ShapeRange, stat As AppStatus, Jitter As Double, cnt&, idx&, _
       x As Double, y As Double, w As Double, h As Double, n&, match%, i&
   Jitter = 0.0001
   On Error Resume Next
   If ActiveSelectionRange.count = 0 Then Set sr = ActivePage.FindShapes _
      Else Set sr = ActiveSelectionRange.Shapes.FindShapes
   If sr.count = 0 Then Exit Sub
   ReDim props(1 To sr.count, 1 To 5): cnt = 0: idx = 0
   Set stat = Application.Status
   stat.BeginProgress "Looking for curve duplicates...", True
   boostStart
   For Each s In sr
      idx = idx + 1: stat.Progress = idx / sr.count * 100
      If stat.Aborted Then Exit For
      x = s.PositionX: y = s.PositionY: n = s.DisplayCurve.Nodes.count
      w = s.SizeWidth: h = s.SizeHeight: match = False
      If w < Jitter And h < Jitter Then
         toDel.Add s: cnt = cnt + 1
      Else
         For i = 1 To cnt
            If stat.Aborted Then Exit For
            If Abs(props(i, 1) - x) < Jitter Then _
               If Abs(props(i, 2) - y) < Jitter Then _
                  If Abs(props(i, 3) - w) < Jitter Then _
                     If Abs(props(i, 4) - h) < Jitter Then _
                        If props(i, 5) = n Then _
                           toDel.Add s: match = True: Exit For
         Next i
         If Not match Then
            cnt = cnt + 1: props(cnt, 1) = x: props(cnt, 2) = y
            props(cnt, 3) = w: props(cnt, 4) = h: props(cnt, 5) = n
         End If
      End If
   Next s
   If stat.Progress > 0 Then stat.EndProgress
   boostFinish
   If toDel.count = 0 Then Exit Sub
   toDel.CreateSelection
   If MsgBox("Confirm delete " + CStr(toDel.count) + " objects", vbOKCancel) = vbOK Then _
      toDel.Delete
End Sub

Public Sub boostStart(Optional ByVal unDo$ = "")
   If unDo <> "" Then ActiveDocument.BeginCommandGroup unDo
   Optimization = True
   EventsEnabled = False
   ActiveDocument.PreserveSelection = False
   End Sub

Public Sub boostFinish(Optional ByVal endUndoGroup% = False)
   ActiveDocument.PreserveSelection = True
   EventsEnabled = True
   Optimization = False
   Application.CorelScript.RedrawScreen
   If endUndoGroup Then ActiveDocument.EndCommandGroup
   End Sub



